var get_list_of_actions = function () {
    var actions = appData.actions;
    var list_of_actions = [];

    for (var action_index in actions) {
        list_of_actions.push(actions[action_index].name);
    }

    return list_of_actions;
};

var get_action_obj_by_name = function (action_name) {
    var actions = appData.actions;
    var obj = null;

    for (var i = 0; i < actions.length; i++) {
        if (actions[i].name === action_name) {
            obj = actions[i];
            break;
        }
    }

    return obj;
};

var get_available_primary_conditions_for_action = function (action_name) {
    if (action_name) {
        var action_name_obj = get_action_obj_by_name(action_name);
        return action_name_obj.available_primary_condition_as_next_step;
    }

    return null;
};

var set_all_actions_container_hidden = function () {
    templateObj.$.ti_widget_container_action_empty.visible = true;

    templateObj.$.ti_widget_container_no_action.visible = false;
    templateObj.$.ti_widget_container_send_transceiver.visible = false;
    templateObj.$.ti_widget_container_send_udp.visible = false;
    templateObj.$.ti_widget_container_send_tcp.visible = false;
    templateObj.$.ti_widget_container_increment_counter.visible = false;
    templateObj.$.ti_widget_container_set_counter.visible = false;
    templateObj.$.ti_widget_container_timer_control.visible = false;
    templateObj.$.ti_widget_container_set_gpio_out.visible = false;
    templateObj.$.ti_widget_container_enter_hibernate.visible = false;
    templateObj.$.ti_widget_container_set_role.visible = false;
    templateObj.$.ti_widget_container_delete_profiles.visible = false;
    templateObj.$.ti_widget_container_set_conn_policy.visible = false;
};

var onActionSelected = function () {
    var device_type = templateObj.$.ti_widget_droplist_device_type.selectedText;

    var selectedValue = templateObj.$.ti_widget_droplist_actions.selectedText;
    console.log(selectedValue);

    set_all_actions_container_hidden();

    if (selectedValue) {
        templateObj.$.ti_widget_container_action_empty.visible = false;

        cachedInjections = [];
        cached_packet_data = null;

        switch (selectedValue) {
            case "None":
                templateObj.$.ti_widget_container_no_action.style.left = action_pos_left;
                templateObj.$.ti_widget_container_no_action.style.top = action_pos_top;

                templateObj.$.ti_widget_container_no_action.visible = true;
                break;
            case "Send Transceiver":
                templateObj.$.ti_widget_droplist_st_channel.labels = get_channels_by_device_type(device_type);
                templateObj.$.ti_widget_droplist_st_rate.labels = get_rates_list().join("|");

                templateObj.$.ti_widget_container_send_transceiver.style.left = action_pos_left;
                templateObj.$.ti_widget_container_send_transceiver.style.top = action_pos_top;

                templateObj.$.ti_widget_container_send_transceiver.visible = true;
                break;
            case "Send UDP":
                templateObj.$.ti_widget_container_send_udp.style.left = action_pos_left;
                templateObj.$.ti_widget_container_send_udp.style.top = action_pos_top;

                templateObj.$.ti_widget_container_send_udp.visible = true;
                break;
            case "Send TCP":
                templateObj.$.ti_widget_container_send_tcp.style.left = action_pos_left;
                templateObj.$.ti_widget_container_send_tcp.style.top = action_pos_top;

                templateObj.$.ti_widget_container_send_tcp.visible = true;
                break;

            case "Increment counter":
                templateObj.$.ti_widget_container_increment_counter.style.left = action_pos_left;
                templateObj.$.ti_widget_container_increment_counter.style.top = action_pos_top;

                templateObj.$.ti_widget_container_increment_counter.visible = true;
                break;

            case "Set counter":
                templateObj.$.ti_widget_container_set_counter.style.left = action_pos_left;
                templateObj.$.ti_widget_container_set_counter.style.top = action_pos_top;

                templateObj.$.ti_widget_container_set_counter.visible = true;
                break;

            case "Timer control":
                templateObj.$.ti_widget_container_timer_control.style.left = action_pos_left;
                templateObj.$.ti_widget_container_timer_control.style.top = action_pos_top;

                templateObj.$.ti_widget_container_timer_control.visible = true;
                break;

            case "Set GPIO (output)":
                templateObj.$.ti_widget_droplist_gpio_out_pad.labels = get_output_pad_numbers(device_type);

                templateObj.$.ti_widget_container_set_gpio_out.style.left = action_pos_left;
                templateObj.$.ti_widget_container_set_gpio_out.style.top = action_pos_top;

                templateObj.$.ti_widget_container_set_gpio_out.visible = true;
                break;

            case "Enter hibernate":
                templateObj.$.ti_widget_container_enter_hibernate.style.left = action_pos_left;
                templateObj.$.ti_widget_container_enter_hibernate.style.top = action_pos_top;

                templateObj.$.ti_widget_container_enter_hibernate.visible = true;
                break;

            case "Set role":
                templateObj.$.ti_widget_container_set_role.style.left = action_pos_left;
                templateObj.$.ti_widget_container_set_role.style.top = action_pos_top;

                templateObj.$.ti_widget_container_set_role.visible = true;
                break;

            case "Delete all profiles":
                templateObj.$.ti_widget_container_delete_profiles.style.left = action_pos_left;
                templateObj.$.ti_widget_container_delete_profiles.style.top = action_pos_top;

                templateObj.$.ti_widget_container_delete_profiles.visible = true;
                break;

            case "Set connection policy":
                templateObj.$.ti_widget_container_set_conn_policy.style.left = action_pos_left;
                templateObj.$.ti_widget_container_set_conn_policy.style.top = action_pos_top;

                templateObj.$.ti_widget_container_set_conn_policy.visible = true;
                break;

        }
    }
};

var getDataForAction = function (rule) {
    var selectedIndex = templateObj.$.ti_widget_droplist_actions.selectedIndex;
    var selectedText = templateObj.$.ti_widget_droplist_actions.selectedText;

    if (selectedIndex === -1) {
        alert("Please select Action before continue forward");
        return undefined;
    }

    var action_obj = get_action_obj_by_name(selectedText);

    rule.action_type = {
        "name": "action_type",
        "raw_val": selectedIndex,
        "val": action_obj.id,
        "size": 4
    };

    rule.action_length = {
        "name": "action_length",
        "raw_val": "",
        "val": "",
        "size": 4
    };

    rule.action_params = [];

    switch (selectedText) {
        case "None":
            var none_padding = {
                "name": "none_padding",
                "raw_val": "",
                "val": "",
                "size": 4
            };
            rule.action_params.push(none_padding);

            rule.action_length.val = "0x4";

            break;

        case "Send Transceiver":
            var st_packet_length_value = parseInt(templateObj.$.ti_widget_numberbox_st_packet_length.value);
            if (st_packet_length_value <= 0) {
                alert("Packet length must be more than zero");
                return undefined;
            }

            var st_packet_length = {
                "name": "st_packet_length",
                "raw_val": templateObj.$.ti_widget_numberbox_st_packet_length.value,
                "val": "0x" + parseInt(templateObj.$.ti_widget_numberbox_st_packet_length.value).toString(16),
                "size": 4
            };
            rule.action_params.push(st_packet_length);

            var cachedInjections = getInjectionList();
            var st_token_length = {
                "name": "st_token_length",
                "raw_val": cachedInjections.length,
                "val": "0x" + (cachedInjections.length * 4).toString(16),
                "size": 4
            };
            rule.action_params.push(st_token_length);

            var st_padding = {
                "name": "st_padding",
                "raw_val": "",
                "val": "",
                "size": 1
            };
            rule.action_params.push(st_padding);

            var st_low_power_5g = {
                "name": "st_low_power_5g",
                "raw_val": templateObj.$.ti_widget_checkbox_st_low_power_5g.checked,
                "val": templateObj.$.ti_widget_checkbox_st_low_power_5g.checked ? "1" : "0",
                "size": 1
            };
            rule.action_params.push(st_low_power_5g);

            var st_repeat = {
                "name": "st_repeat",
                "raw_val": templateObj.$.ti_widget_numberbox_st_repeat.value,
                "val": "0x" + parseInt(templateObj.$.ti_widget_numberbox_st_repeat.value).toString(16),
                "size": 1
            };
            rule.action_params.push(st_repeat);

            var channel = templateObj.$.ti_widget_droplist_st_channel.selectedText;
            var rate_index = templateObj.$.ti_widget_droplist_st_rate.selectedIndex;

            // rates 1 Mbps / 2 Mbps / 5.5 Mbps / 11 Mbps are 4 first in selection of dropdown box
            if (get_5G_channels().includes(channel) && rate_index <= 3) {
                alert("Rates 1 Mbps /  2 Mbps / 5.5 Mbps / 11 Mbps can't be use on 5G channels");
                return undefined;
            }

            var st_channel = {
                "name": "st_channel",
                "raw_val": templateObj.$.ti_widget_droplist_st_channel.selectedIndex,
                "val": "0x" + parseInt(templateObj.$.ti_widget_droplist_st_channel.selectedText).toString(16),
                "size": 1
            };
            rule.action_params.push(st_channel);

            var st_rate = {
                "name": "st_rate",
                "raw_val": templateObj.$.ti_widget_droplist_st_rate.selectedText,
                "val": "0x" + parseInt(get_rate_value_by_name(templateObj.$.ti_widget_droplist_st_rate.selectedText)).toString(16),
                "size": 1
            };
            rule.action_params.push(st_rate);

            var st_power = {
                "name": "st_power",
                "raw_val": templateObj.$.ti_widget_droplist_st_power.selectedIndex,
                "val": "0x" + templateObj.$.ti_widget_droplist_st_power.selectedIndex.toString(16),
                "size": 1
            };
            rule.action_params.push(st_power);

            var st_preamble = {
                "name": "st_preamble",
                "raw_val": templateObj.$.ti_widget_droplist_st_preamble.selectedIndex,
                "val": "0x" + templateObj.$.ti_widget_droplist_st_preamble.selectedIndex.toString(16),
                "size": 1
            };
            rule.action_params.push(st_preamble);

            var st_cca_override = {
                "name": "st_cca_override",
                "raw_val": templateObj.$.ti_widget_checkbox_st_ccs_override.checked,
                "val": templateObj.$.ti_widget_checkbox_st_ccs_override.checked ? "1" : "0",
                "size": 1
            };
            rule.action_params.push(st_cca_override);

            save_injection_data_into_array(rule.action_params, "st");

            save_packet_data_into_array(rule.action_params, "st", st_packet_length_value);

            rule.action_length.val = "0x" + (4 /*PacketLen*/ + 4 /*TokensLen*/ + 1 /*Padding*/ + 1 /*LowPower5G*/ + 6 /*others parameters*/ + cachedInjections.length * 4 + st_packet_length_value).toString(16);

            break;

        case "Send UDP":
            var su_packet_length_value = parseInt(templateObj.$.ti_widget_numberbox_su_packet_length.value);
            if (su_packet_length_value <= 0) {
                alert("Packet length must be more than zero");
                return undefined;
            }

            var su_target_ip_len = {
                "name": "su_target_ip_len",
                "raw_val": 4,
                "val": "0x04",
                "size": 4
            };
            rule.action_params.push(su_target_ip_len);

            var cachedInjections = getInjectionList();
            var su_token_length = {
                "name": "su_token_length",
                "raw_val": cachedInjections.length,
                "val": "0x" + (cachedInjections.length * 4).toString(16),
                "size": 4
            };
            rule.action_params.push(su_token_length);

            var su_packet_length = {
                "name": "su_packet_length",
                "raw_val": templateObj.$.ti_widget_numberbox_su_packet_length.value,
                "val": "0x" + templateObj.$.ti_widget_numberbox_su_packet_length.value.toString(16),
                "size": 4
            };
            rule.action_params.push(su_packet_length);

            var su_port_number = {
                "name": "su_port_number",
                "raw_val": templateObj.$.ti_widget_numberbox_su_port_number.value,
                "val": "0x" + templateObj.$.ti_widget_numberbox_su_port_number.value.toString(16),
                "size": 2
            };
            rule.action_params.push(su_port_number);

            var su_options = {
                "name": "su_options",
                "raw_val": "",
                "val": "",
                "size": 2
            };
            rule.action_params.push(su_options);

            var ip = templateObj.$.ti_widget_input_su_ip_address.value;
            if (!checkIsIPV4(ip)) {
                alert("IP is incorrect, update and try again.");
                return undefined;
            }

            var su_ip = {
                "name": "su_ip",
                "raw_val": ip,
                "val": convertIPV4toHex(ip),
                "size": 4
            };
            rule.action_params.push(su_ip);

            save_injection_data_into_array(rule.action_params, "su");

            save_packet_data_into_array(rule.action_params, "su", su_packet_length_value);

            rule.action_length.val = "0x" + (4 /*TargetIPLen*/ + 4 /*TokensLen*/ + 4 /*PacketLen*/ + 2 /*Port*/ + 2 /*Options*/ + 4 /*IP*/ + cachedInjections.length * 4 + su_packet_length_value).toString(16);

            break;

        case "Send TCP":
            var tcp_packet_length_value = parseInt(templateObj.$.ti_widget_numberbox_tcp_packet_length.value);
            if (tcp_packet_length_value <= 0) {
                alert("Packet length must be more than zero");
                return undefined;
            }

            var tcp_target_ip_len = {
                "name": "tcp_target_ip_len",
                "raw_val": 4,
                "val": "0x04",
                "size": 4
            };
            rule.action_params.push(tcp_target_ip_len);

            var cachedInjections = getInjectionList();
            var tcp_token_length = {
                "name": "tcp_token_length",
                "raw_val": cachedInjections.length,
                "val": "0x" + (cachedInjections.length * 4).toString(16),
                "size": 4
            };
            rule.action_params.push(tcp_token_length);

            var tcp_packet_length = {
                "name": "tcp_packet_length",
                "raw_val": templateObj.$.ti_widget_numberbox_tcp_packet_length.value,
                "val": "0x" + templateObj.$.ti_widget_numberbox_tcp_packet_length.value.toString(16),
                "size": 4
            };
            rule.action_params.push(tcp_packet_length);

            var tcp_port_number = {
                "name": "tcp_port_number",
                "raw_val": templateObj.$.ti_widget_numberbox_tcp_port_number.value,
                "val": "0x" + templateObj.$.ti_widget_numberbox_tcp_port_number.value.toString(16),
                "size": 2
            };
            rule.action_params.push(tcp_port_number);

            var tcp_options = {
                "name": "tcp_options",
                "raw_val": "",
                "val": "",
                "size": 2
            };
            rule.action_params.push(tcp_options);

            var tcpip = templateObj.$.ti_widget_input_tcp_ip_address.value;
            if (!checkIsIPV4(tcpip)) {
                alert("IP is incorrect, update and try again.");
                return undefined;
            }

            var tcp_ip = {
                "name": "tcp_ip",
                "raw_val": tcpip,
                "val": convertIPV4toHex(tcpip),
                "size": 4
            };
            rule.action_params.push(tcp_ip);

            save_injection_data_into_array(rule.action_params, "tcp");

            save_packet_data_into_array(rule.action_params, "tcp", tcp_packet_length_value);

            rule.action_length.val = "0x" + (4 /*TargetIPLen*/ + 4 /*TokensLen*/ + 4 /*PacketLen*/ + 2 /*Port*/ + 2 /*Options*/ + 4 /*IP*/ + cachedInjections.length * 4 + tcp_packet_length_value).toString(16);

            break;

        case "Increment counter":
            var inc_count_padding = {
                "name": "inc_count_padding",
                "raw_val": "",
                "val": "",
                "size": 4
            };
            rule.action_params.push(inc_count_padding);

            var inc_count_counter_number = {
                "name": "inc_count_counter_number",
                "raw_val": templateObj.$.ti_widget_droplist_inc_cout_counter_number.selectedText,
                "val": "0x" + templateObj.$.ti_widget_droplist_inc_cout_counter_number.selectedText.toString(16),
                "size": 2
            };
            rule.action_params.push(inc_count_counter_number);

            var inc_count_counter_volatile = {
                "name": "inc_count_counter_volatile",
                "raw_val": templateObj.$.ti_widget_droplist_inc_cout_volatile.selectedIndex,
                "val": "0x" + templateObj.$.ti_widget_droplist_inc_cout_volatile.selectedIndex.toString(16),
                "size": 2
            };
            rule.action_params.push(inc_count_counter_volatile);

            rule.action_length.val = "0x" + (4 + 2 + 2).toString(16);

            break;

        case "Set counter":
            var set_count_counter_value = {
                "name": "set_count_counter_value",
                "raw_val": templateObj.$.ti_widget_numberbox_set_count_counter_value.value,
                "val": "0x" + parseInt(templateObj.$.ti_widget_numberbox_set_count_counter_value.value).toString(16),
                "size": 4
            };
            rule.action_params.push(set_count_counter_value);

            var set_count_counter_number = {
                "name": "set_count_counter_number",
                "raw_val": templateObj.$.ti_widget_droplist_set_count_counter_number.selectedText,
                "val": "0x" + templateObj.$.ti_widget_droplist_set_count_counter_number.selectedText.toString(16),
                "size": 2
            };
            rule.action_params.push(set_count_counter_number);

            var set_count_counter_volatile = {
                "name": "set_count_counter_volatile",
                "raw_val": templateObj.$.ti_widget_droplist_set_count_volatile.selectedIndex,
                "val": "0x" + templateObj.$.ti_widget_droplist_set_count_volatile.selectedIndex.toString(16),
                "size": 2
            };
            rule.action_params.push(set_count_counter_volatile);

            rule.action_length.val = "0x" + (4 + 2 + 2).toString(16);

            break;

        case "Timer control":
            var tmr_ctrl_duration = {
                "name": "tmr_ctrl_duration",
                "raw_val": templateObj.$.ti_widget_numberbox_tmr_ctrl_duration.value,
                "val": "0x" + parseInt(templateObj.$.ti_widget_numberbox_tmr_ctrl_duration.value).toString(16),
                "size": 4
            };
            rule.action_params.push(tmr_ctrl_duration);

            var tmr_ctrl_timer_number = {
                "name": "tmr_ctrl_timer_number",
                "raw_val": templateObj.$.ti_widget_droplist_tmr_ctrl_timer_number.selectedText,
                "val": "0x" + templateObj.$.ti_widget_droplist_tmr_ctrl_timer_number.selectedText.toString(16),
                "size": 2
            };
            rule.action_params.push(tmr_ctrl_timer_number);

            var tmr_ctrl_action = {
                "name": "tmr_ctrl_action",
                "raw_val": templateObj.$.ti_widget_droplist_tmr_ctrl_action.selectedIndex,
                "val": "0x" + templateObj.$.ti_widget_droplist_tmr_ctrl_action.selectedIndex.toString(16),
                "size": 2
            };
            rule.action_params.push(tmr_ctrl_action);

            rule.action_length.val = "0x" + (4 + 2 + 2).toString(16);

            break;


        case "Set GPIO (output)":
            var options = {
                "name": "zero padding",
                "raw_val": "",
                "val": "",
                "size": 2
            };
            rule.action_params.push(options);

            var pad_number = {
                "name": "pad number",
                "raw_val": templateObj.$.ti_widget_droplist_gpio_out_pad.selectedIndex,
                "val": templateObj.$.ti_widget_droplist_gpio_out_pad.selectedText,
                "size": 1
            };
            rule.action_params.push(pad_number);

            var pad_value = {
                "name": "pad value",
                "raw_val": templateObj.$.ti_widget_droplist_gpio_out_value.selectedIndex,
                "val": templateObj.$.ti_widget_droplist_gpio_out_value.selectedIndex.toString(),
                "size": 1
            };
            rule.action_params.push(pad_value);

            var strength = {
                "name": "pad strength",
                "raw_val": templateObj.$.ti_widget_droplist_gpio_out_strength.selectedIndex,
                // +1 because "No drive" should be zero but it removed therefor "2mA" index 0 but value must be 1
                "val": (templateObj.$.ti_widget_droplist_gpio_out_strength.selectedIndex + 1).toString(),
                "size": 1
            };
            rule.action_params.push(strength);

            var pull = {
                "name": "pad pull",
                "raw_val": templateObj.$.ti_widget_droplist_gpio_out_pull.selectedIndex,
                "val": templateObj.$.ti_widget_droplist_gpio_out_pull.selectedIndex.toString(),
                "size": 1
            };
            rule.action_params.push(pull);

            var retention = {
                "name": "retention",
                "raw_val": templateObj.$.ti_widget_droplist_gpio_out_retention.selectedIndex,
                "val": templateObj.$.ti_widget_droplist_gpio_out_retention.selectedIndex.toString(),
                "size": 1
            };
            rule.action_params.push(retention);

            var open_drain = {
                "name": "open drain",
                "raw_val": templateObj.$.ti_widget_checkbox_gpio_out_open_drain.checked,
                "val": templateObj.$.ti_widget_checkbox_gpio_out_open_drain.checked ? "1" : "0",
                "size": 1
            };
            rule.action_params.push(open_drain);

            rule.action_length.val = "0x08";

            break;

        case "Enter hibernate":
            var hib_time = {
                "name": "hib_time",
                "raw_val": templateObj.$.ti_widget_numberbox_hib_time.value,
                "val": (templateObj.$.ti_widget_numberbox_hib_time.value * 32768).toString(16),
                "size": 4
            };
            rule.action_params.push(hib_time);

            var hib_stop_time = {
                "name": "hib_stop_time",
                "raw_val": "",
                "val": "0xFF",
                "size": 1
            };
            rule.action_params.push(hib_stop_time);

            var hib_wake_by_gpio_selected = {
                "name": "hib_wake_by_gpio_selected",
                "raw_val": templateObj.$.ti_widget_checkbox_hib_wake_by_gpio.checked,
                "val": "",
                "size": 0
            };
            rule.action_params.push(hib_wake_by_gpio_selected);


            var hib_wake_gpio = {
                "name": "hib_wake_gpio",
                "raw_val": templateObj.$.ti_widget_droplist_hib_wake_gpio.selectedIndex,
                "val": Math.pow(2, templateObj.$.ti_widget_droplist_hib_wake_gpio.selectedIndex).toString(16),
                "size": 1
            };
            rule.action_params.push(hib_wake_gpio);

            var hib_wake_gpio_conf = {
                "name": "hib_wake_gpio_conf",
                "raw_val": templateObj.$.ti_widget_droplist_hib_gpio_conf.selectedIndex,
                "val": (templateObj.$.ti_widget_droplist_hib_gpio_conf.selectedIndex << (hib_wake_gpio.raw_val * 2)).toString(16),
                "size": 2
            };
            rule.action_params.push(hib_wake_gpio_conf);

            rule.action_length.val = "0x08";

            break;

        case "Set role":
            var sr_padding = {
                "name": "sr_padding",
                "raw_val": "",
                "val": "",
                "size": 2
            };
            rule.action_params.push(sr_padding);

            var sr_role = {
                "name": "sr_role",
                "raw_val": templateObj.$.ti_widget_droplist_set_role_value.selectedIndex,
                "val": "0x" + templateObj.$.ti_widget_droplist_set_role_value.selectedIndex.toString(16),
                "size": 1
            };
            rule.action_params.push(sr_role);

            var sr_restart = {
                "name": "sr_restart",
                "raw_val": templateObj.$.ti_widget_droplist_set_role_restart.selectedIndex,
                "val": "0x" + templateObj.$.ti_widget_droplist_set_role_restart.selectedIndex.toString(16),
                "size": 1
            };
            rule.action_params.push(sr_restart);

            rule.action_length.val = "0x04";

            break;

        case "Delete all profiles":
            var dap_padding_spare = {
                "name": "dap_padding_spare",
                "raw_val": "",
                "val": "",
                "size": 4
            };
            rule.action_params.push(dap_padding_spare);

            rule.action_length.val = "0x04";

            break;

        case "Set connection policy":
            var scp_padding = {
                "name": "scp_padding1",
                "raw_val": "",
                "val": "",
                "size": 1
            };
            rule.action_params.push(scp_padding);

            var scp_fast_connect = {
                "name": "scp_fast_connect",
                "raw_val": templateObj.$.ti_widget_checkbox_conn_poly_fast_connect.checked,
                "val": templateObj.$.ti_widget_checkbox_conn_poly_fast_connect.checked ? "1" : "0",
                "size": 1
            };
            rule.action_params.push(scp_fast_connect);

            var scp_connect_to_open_ap = {
                "name": "scp_connect_to_open_ap",
                "raw_val": templateObj.$.ti_widget_checkbox_conn_poly_connect_to_open_ap.checked,
                "val": templateObj.$.ti_widget_checkbox_conn_poly_connect_to_open_ap.checked ? "1" : "0",
                "size": 1
            };
            rule.action_params.push(scp_connect_to_open_ap);

            var scp_auto_start = {
                "name": "scp_auto_start",
                "raw_val": templateObj.$.ti_widget_checkbox_conn_poly_auto_start.checked,
                "val": templateObj.$.ti_widget_checkbox_conn_poly_auto_start.checked ? "1" : "0",
                "size": 1
            };
            rule.action_params.push(scp_auto_start);

            var scp_connect_any_p2p = {
                "name": "scp_connect_any_p2p",
                "raw_val": templateObj.$.ti_widget_checkbox_conn_poly_connect_any_p2p.checked,
                "val": templateObj.$.ti_widget_checkbox_conn_poly_connect_any_p2p.checked ? "1" : "0",
                "size": 1
            };
            rule.action_params.push(scp_connect_any_p2p);

            var scp_auto_smart_config = {
                "name": "scp_auto_smart_config",
                "raw_val": templateObj.$.ti_widget_checkbox_conn_poly_auto_smart_config.checked,
                "val": templateObj.$.ti_widget_checkbox_conn_poly_auto_smart_config.checked ? "1" : "0",
                "size": 1
            };
            rule.action_params.push(scp_auto_smart_config);

            var scp_auto_provisioning = {
                "name": "scp_auto_provisioning",
                "raw_val": templateObj.$.ti_widget_checkbox_conn_poly_auto_provisioning.checked,
                "val": templateObj.$.ti_widget_checkbox_conn_poly_auto_provisioning.checked ? "1" : "0",
                "size": 1
            };
            rule.action_params.push(scp_auto_provisioning);

            rule.action_params.push(scp_padding);

            rule.action_length.val = "0x08";

            break;
    }

    return rule;
};

var loadDataForActions = function (rule) {
    templateObj.$.ti_widget_droplist_actions.selectedIndex = rule.action_type.raw_val;
    onActionSelected();

    var selectedText = templateObj.$.ti_widget_droplist_actions.selectedText;
    switch (selectedText) {
        case "None":
            break;

        case "Send Transceiver":
            templateObj.$.ti_widget_numberbox_st_packet_length.value = get_value_by_name(rule.action_params, "st_packet_length");
            templateObj.$.ti_widget_numberbox_st_repeat.value = get_value_by_name(rule.action_params, "st_repeat");
            templateObj.$.ti_widget_droplist_st_channel.selectedIndex = get_value_by_name(rule.action_params, "st_channel");
            templateObj.$.ti_widget_droplist_st_rate.selectedText = get_value_by_name(rule.action_params, "st_rate");
            templateObj.$.ti_widget_droplist_st_power.selectedIndex = get_value_by_name(rule.action_params, "st_power");
            templateObj.$.ti_widget_droplist_st_preamble.selectedIndex = get_value_by_name(rule.action_params, "st_preamble");
            templateObj.$.ti_widget_checkbox_st_low_power_5g.checked = get_value_by_name(rule.action_params, "st_low_power_5g");
            templateObj.$.ti_widget_checkbox_st_ccs_override.checked = get_value_by_name(rule.action_params, "st_cca_override");
            
            load_injection_data_from_array(rule.action_params, "st");
            load_packet_data_from_array(rule.action_params, "st");

            break;

        case "Send UDP":
            templateObj.$.ti_widget_numberbox_su_packet_length.value = get_value_by_name(rule.action_params, "su_packet_length");
            templateObj.$.ti_widget_numberbox_su_port_number.value = get_value_by_name(rule.action_params, "su_port_number");
            templateObj.$.ti_widget_input_su_ip_address.value = get_value_by_name(rule.action_params, "su_ip");
            load_injection_data_from_array(rule.action_params, "su");
            load_packet_data_from_array(rule.action_params, "su");

            break;

        case "Send TCP":
            templateObj.$.ti_widget_numberbox_tcp_packet_length.value = get_value_by_name(rule.action_params, "tcp_packet_length");
            templateObj.$.ti_widget_numberbox_tcp_port_number.value = get_value_by_name(rule.action_params, "tcp_port_number");
            templateObj.$.ti_widget_input_tcp_ip_address.value = get_value_by_name(rule.action_params, "tcp_ip");
            load_injection_data_from_array(rule.action_params, "tcp");
            load_packet_data_from_array(rule.action_params, "tcp");

            break;

        case "Increment counter":
            templateObj.$.ti_widget_droplist_inc_cout_counter_number.selectedText = get_value_by_name(rule.action_params, "inc_count_counter_number");
            templateObj.$.ti_widget_droplist_inc_cout_volatile.selectedIndex = get_value_by_name(rule.action_params, "inc_count_counter_volatile");

            break;

        case "Set counter":
            templateObj.$.ti_widget_numberbox_set_count_counter_value.value = get_value_by_name(rule.action_params, "set_count_counter_value");
            templateObj.$.ti_widget_droplist_set_count_counter_number.selectedText = get_value_by_name(rule.action_params, "set_count_counter_number");
            templateObj.$.ti_widget_droplist_set_count_volatile.selectedIndex = get_value_by_name(rule.action_params, "set_count_counter_volatile");

            break;

        case "Timer control":
            templateObj.$.ti_widget_numberbox_tmr_ctrl_duration.value = get_value_by_name(rule.action_params, "tmr_ctrl_duration");
            templateObj.$.ti_widget_droplist_tmr_ctrl_timer_number.selectedText = get_value_by_name(rule.action_params, "tmr_ctrl_timer_number");
            templateObj.$.ti_widget_droplist_tmr_ctrl_action.selectedIndex = get_value_by_name(rule.action_params, "tmr_ctrl_action");

            break;

        case "Set GPIO (output)":
            templateObj.$.ti_widget_droplist_gpio_out_pad.selectedIndex = get_value_by_name(rule.action_params, "pad number");
            templateObj.$.ti_widget_droplist_gpio_out_value.selectedIndex = get_value_by_name(rule.action_params, "pad value");
            templateObj.$.ti_widget_droplist_gpio_out_strength.selectedIndex = get_value_by_name(rule.action_params, "pad strength");
            templateObj.$.ti_widget_droplist_gpio_out_pull.selectedIndex = get_value_by_name(rule.action_params, "pad pull");
            templateObj.$.ti_widget_droplist_gpio_out_retention.selectedIndex = get_value_by_name(rule.action_params, "retention");
            templateObj.$.ti_widget_checkbox_gpio_out_open_drain.checked = get_value_by_name(rule.action_params, "open drain");

            break;

        case "Enter hibernate":
            templateObj.$.ti_widget_numberbox_hib_time.value = get_value_by_name(rule.action_params, "hib_time");
            templateObj.$.ti_widget_checkbox_hib_wake_by_gpio.checked = get_value_by_name(rule.action_params, "hib_wake_by_gpio_selected");
            templateObj.$.ti_widget_container_hib_wake_by_gpio.visible = templateObj.$.ti_widget_checkbox_hib_wake_by_gpio.checked;
            templateObj.$.ti_widget_droplist_hib_wake_gpio.selectedIndex = get_value_by_name(rule.action_params, "hib_wake_gpio");
            templateObj.$.ti_widget_droplist_hib_gpio_conf.selectedIndex = get_value_by_name(rule.action_params, "hib_wake_gpio_conf");

            break;

        case "Set role":
            templateObj.$.ti_widget_droplist_set_role_value.selectedIndex = get_value_by_name(rule.action_params, "sr_role");
            templateObj.$.ti_widget_droplist_set_role_restart.selectedIndex = get_value_by_name(rule.action_params, "sr_restart");

            break;

        case "Delete all profiles":
            break;

        case "Set connection policy":
            templateObj.$.ti_widget_checkbox_conn_poly_fast_connect.checked = get_value_by_name(rule.action_params, "scp_fast_connect");
            templateObj.$.ti_widget_checkbox_conn_poly_connect_to_open_ap.checked = get_value_by_name(rule.action_params, "scp_connect_to_open_ap");
            templateObj.$.ti_widget_checkbox_conn_poly_auto_start.checked = get_value_by_name(rule.action_params, "scp_auto_start");
            templateObj.$.ti_widget_checkbox_conn_poly_connect_any_p2p.checked = get_value_by_name(rule.action_params, "scp_connect_any_p2p");
            templateObj.$.ti_widget_checkbox_conn_poly_auto_smart_config.checked = get_value_by_name(rule.action_params, "scp_auto_smart_config");
            templateObj.$.ti_widget_checkbox_conn_poly_auto_provisioning.checked = get_value_by_name(rule.action_params, "scp_auto_provisioning");

            break;

    }
};

var onSetConnectionPolicySelectNone = function () {
    templateObj.$.ti_widget_checkbox_conn_poly_fast_connect.checked = false;
    templateObj.$.ti_widget_checkbox_conn_poly_connect_to_open_ap.checked = false;
    templateObj.$.ti_widget_checkbox_conn_poly_auto_start.checked = false;
    templateObj.$.ti_widget_checkbox_conn_poly_connect_any_p2p.checked = false;
    templateObj.$.ti_widget_checkbox_conn_poly_auto_smart_config.checked = false;
    templateObj.$.ti_widget_checkbox_conn_poly_auto_provisioning.checked = false;
};

var showEditPacket = function (packet_length, previous_data = null, wlan_frame = null) {
    var ta_packet_raw_view = document.getElementById("packet_raw_view");
    ta_packet_raw_view.value = "";
    ta_packet_raw_view.style.width = "100%";
    ta_packet_raw_view.style.height = "97%";

    var ta_packet_ascii_view = document.getElementById("packet_ascii_view");
    ta_packet_ascii_view.value = "";
    ta_packet_ascii_view.style.width = "100%";
    ta_packet_ascii_view.style.height = "97%";

    var packet_data = Array(packet_length).fill('FF');
    if (previous_data && previous_data.length > 0) {
        packet_data = previous_data;
    }

    templateObj.$.ti_widget_button_packet_place_wlan_frame.visible = false;
    if ( wlan_frame && wlan_frame === true) {
        templateObj.$.ti_widget_button_packet_place_wlan_frame.visible = true;
    }

    generate_hex_view_for(packet_length, packet_data);

    var okBtn = window.document.getElementById("dlg_btn_save");
    okBtn.addEventListener("click", function (e) {
        window.setTimeout(function () {
            cached_packet_data = get_packet_data();
            updateLengthBack(cached_packet_data.length);

            window.document.removeEventListener("click", okBtn, false);
        }, 10);
    });

    var dlg = window.document.getElementById("dlg_packet_data");
    dlg.isModal = true;
    dlg.open();
};

var onEditPacket = function () {
    var pCount = parseInt(templateObj.$.ti_widget_numberbox_st_packet_length.value);

    showEditPacket(pCount, cached_packet_data, true);
};

var onSendUdpEditPacket = function () {
    var pCount = parseInt(templateObj.$.ti_widget_numberbox_su_packet_length.value);

    showEditPacket(pCount, cached_packet_data);
};

var onSendTcpEditPacket = function () {
    var pCount = parseInt(templateObj.$.ti_widget_numberbox_tcp_packet_length.value);

    showEditPacket(pCount, cached_packet_data);
};

var onDataInject = function () {
    initInjectionEditor();

    if (cachedInjections && cachedInjections.length > 0) {
        createInjectionList(cachedInjections);
    }

    var dlg = window.document.getElementById("dlg_packet_data_injection");
    dlg.isModal = true;
    dlg.open();
};

var onHibWakeByGPIO = function () {
    var checkBoxChecked = templateObj.$.ti_widget_checkbox_hib_wake_by_gpio.checked;

    templateObj.$.ti_widget_container_hib_wake_by_gpio.visible = checkBoxChecked;

    templateObj.$.ti_widget_droplist_hib_wake_gpio.selectedText = "None";
    templateObj.$.ti_widget_droplist_hib_gpio_conf.selectedText = "Low";
};

var onChannelChange = function () {
    var channel = templateObj.$.ti_widget_droplist_st_channel.selectedText;
    templateObj.$.ti_widget_checkbox_st_low_power_5g.checked = false;

    console.log(get_5G_channels().includes(channel));

    if (get_5G_channels().includes(channel)) {
        templateObj.$.ti_widget_checkbox_st_low_power_5g.disabled = false;
    } else {
        templateObj.$.ti_widget_checkbox_st_low_power_5g.disabled = true;
    }
};